﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace LF_FDXHDX
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
          bool re=  RFID_LF.InitModule();
        re=  RFID_LF.SetSerialBaudRate(0, 9600);
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            RFID_LF.freeMode();
        }

        private void button1_Click(object sender, EventArgs e)
        {

            Scan();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBoxRes.Text = "";
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 139 || e.KeyValue == 238)
            {
                Scan();
            }
        }

        void Scan()
        {
            try
            {
                button1.Enabled = false;
                byte[] pszData = new byte[1];
                byte[] strType = new byte[1];
                if (RFID_LF.ReadAniTag(ref pszData, ref strType))
                {

                    string strdata = System.Text.Encoding.ASCII.GetString(pszData, 0, pszData.Length);
                    Sound.Play(1);
                    if (strType[0] == 1)

                        textBoxRes.Text = "HDX tag sn" + ":" + strdata + "\r\n" + textBoxRes.Text;
                    else if (strType[0] == 2)
                        textBoxRes.Text = "FDX tag sn" + ":" + strdata + "\r\n" + textBoxRes.Text;
                    else
                        textBoxRes.Text = "tag sn" + ":" + strdata + "\r\n" + textBoxRes.Text;
                }
                else
                {
                    textBoxRes.Text = "Read  Fail" + "\r\n" + textBoxRes.Text;
                }
            }
            catch
            {

            }
            finally
            {
                button1.Enabled = true;
            }
        }
        
    }
}