using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Text.RegularExpressions;

namespace LF_FDXHDX
{
    /// <summary>
    /// װֳֻƵRFIDܵزķ
    /// </summary>
    public class RFID_LF
    {
        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_init")]
        private static extern bool EM125k_init();

        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_free")]
        private static extern bool EM125k_free();

        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_read")]
        private static extern int EM125k_read(int iMode, byte[] pszData);

        [DllImport("DeviceAPI.dll", EntryPoint = "EM_125kread")]
        private static extern int EM_125kread(int iMode, byte[] pszData);

        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_UID_REQ")]
        private static extern int EM125k_UID_REQ(int iMode, byte[] pszData);

        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_WriteHitagPage")]
        private static extern int EM125k_WriteHitagPage(int nPage, byte[] pszData);


        [DllImport("DeviceAPI.dll", EntryPoint = "EM125K_GetEm4450UID")]
        private static extern int EM125K_GetEm4450UID(byte[] pszData);

        [DllImport("DeviceAPI.dll", EntryPoint = "HID_ReadID")]
        private static extern int HID_ReadID(uint[] uid, byte[] ExtData);


        //Կ....................................................
        /// <summary>
        /// ֤Կ
        /// </summary>
        /// <param name="ukey">ukey--4ֽԿĬΪ(0x00,0x00,0x00,0x00)</param>
        /// <returns></returns>
        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_EM4305_KEY_AUTH")]
        private static extern int EM125k_EM4305_KEY_AUTH(byte[] ukey);

        /// <summary>
        /// ޸Կ
        /// </summary>
        /// <param name="oldkey">ԭԿ</param>
        /// <param name="newkey">Կ</param>
        /// <returns></returns>
       [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_EM4305_KEY_CHANGE")]
        private static extern int EM125k_EM4305_KEY_CHANGE(byte[] oldkey,byte[] newkey);
     

       /// <summary>
       /// ܹ
       /// </summary>
       /// <param name="ukey"></param>
       /// <returns></returns>
       [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_EM4305_KEY_ENABLE")]
        private static extern int EM125k_EM4305_KEY_ENABLE(byte[] ukey);


       /// <summary>
       /// üܹ
       /// </summary>
       /// <param name="ukey"></param>
       /// <returns></returns>
       [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_EM4305_KEY_DISABLE")]
       private static extern int EM125k_EM4305_KEY_DISABLE(byte[] ukey);


       [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_Read4305_EX")]
        private static extern int EM125k_Read4305_EX(byte[] ukey,int nPage,byte[] pszData);

       [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_Write4305_EX")]
        private static extern int EM125k_Write4305_EX(byte[] ukey,int nPage,byte[] pszData);

 
 

        //.............................................................

         

        /**************************** EM4305 ********************************
       4305ĳһҳ0~31                                        
       nPage  -- ҳַ(0~31)
	             035~13ҳɶдɹû洢ʹ
				 1ҳΪUID洢ֻ
				 2ҳΪ
				 4ҳΪ
				 1415ҳΪ
	pszData-- 4ֽݣÿҳɴ4ֽڣ
	************************************************************************/
        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_Read4305")]
        private static extern int EM125k_Read4305(int nPage, byte[] pszData);

        /**************************** дEM4305 ********************************
        д4305ĳһҳ0~31                                        
        nPage  -- ҳַ(0~31)
                     035~13ҳɶдɹû洢ʹ
                     1ҳΪUID洢ֻ
                     2ҳΪ
                     4ҳΪ
                     1415ҳΪ
                  pszData-- 4ֽݣÿҳɴ4ֽڣ
        ************************************************************************/
        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_Write4305")]
        private static extern int EM125k_Write4305(int nPage, byte[] pszData);

        /************************************************************************/
        /* ȡHitag Sеĳһҳ                                                */
        /* nPage ҳ	*/
        /* pszData ȡϢpszData[0]ΪݳȣݴpszData[1]ʼ	*/
        /************************************************************************/
        [DllImport("DeviceAPI.dll", EntryPoint = "EM125k_ReadHitag")]
        private static extern int EM125k_ReadHitag(int nPage, byte[] pszData);


        [DllImport("DeviceAPI.dll", EntryPoint = "Animal_ReadTag_EX")]
        private static extern int Animal_ReadTag_EX(byte[] pszData, byte[] type);

        /// <summary>
        /// ȡRFIDоƬĹ̼汾
        /// </summary>
        /// <param name="pszData"></param>
        /// <returns></returns>
        [DllImport("DeviceAPI.dll", EntryPoint = "HardwareVersion_Ex")]
        private static extern int HardwareVersion_Ex(byte[] pszData);



        /************************************************************************/
        /* ùܴڲ							     
        iModule:ģ   
                        0:RFID_LF,  1:RFID_HF   2:RFID_UHF
        iBaudRate: :
				         :1200:
				         :2400:
				         :4800:
				         :9600:
				         :14400:
				         :19200:
				         :28800:
				         :38400:
				         :57600:
				         :115200:
        */
        /************************************************************************/
        [DllImport("DeviceAPI.dll", EntryPoint = "SetSerialPortBaudRate")]
        public static extern bool SetSerialPortBaudRate(int iModule, int iBaudRate);

        /// <summary>
        /// IDǩʾʽtrueΪ16ʾflaseΪ10ʾ
        /// </summary>
        public static bool Format_IDTag_hex = true;


        /// <summary>
        /// ǩϢ
        /// </summary>
        public struct animalCard
        {
            /// <summary>
            /// ǩNationalIDϢ
            /// </summary>
            public UInt64 NationalID;

            /// <summary>
            /// ǩĹҴ
            /// </summary>
            public int CountryID;

            /// <summary>
            /// ǩReservedϢ
            /// </summary>
            public int Reserved;

            /// <summary>
            /// ǩDataBlock
            /// </summary>
            public int DataBlock;

            /// <summary>
            /// ǩAnimalFlag
            /// </summary>
            public int AnimalFlag;
        }

        /// <summary>
        /// ģϵ磬Դ
        /// </summary>
        /// <returns></returns>
        public static bool InitModule()
        {
            return EM125k_init();           
        }

        /// <summary>
        /// ģϵ磬ͷŴԴ
        /// </summary>
        public static bool freeMode()
        {
            return EM125k_free();
        }

        public static bool ReadAniTag(ref byte[] data_ID, ref byte[] type)
        {
            byte[] pszData = new byte[255];
            byte[] tagType = new byte[5];
            try
            {
                int res = 0;
                res = Animal_ReadTag_EX(pszData, tagType);
                if (res == 0)
                {
                    data_ID = new byte[pszData[0]];
                    for (int i = 0; i < data_ID.Length; i++)
                    {
                        data_ID[i] = pszData[i + 1];
                    }
                    type[0] = tagType[0];
                    return true;
                }
                else
                {
                    data_ID = new byte[2];
                    type = new byte[1];
                    return false;
                }
            }
            catch (System.Exception ex)
            {
                return false;
            }

        }

        /// <summary>
        /// ȡ汾
        /// </summary>
        public static string GetHardware_version()
        {
            try
            {
                byte[] pszData = new byte[255];


                int iRes = HardwareVersion_Ex(pszData);


                string str = "";
                if (iRes == 0)
                {
                    str = System.Text.Encoding.GetEncoding("ascii").GetString(pszData, 1, pszData[0]);
                }
                return str;
            }
            catch (System.Exception)
            {
                return "";
            }
        }




        
        /// <summary>
        /// ȡHiTagǩ
        /// </summary>
        /// <param name="data_ID">ǩϢ</param>
        /// <returns></returns>
        public static bool ReadHiTag(ref byte[] data_ID)
        {
            byte[] pszData = new byte[32];
            int res = 0;
            res = EM125k_UID_REQ(0, pszData);
            if (res == 0)
            {
                data_ID = new byte[pszData[0]];
                for (int i = 0; i < data_ID.Length; i++)
                {
                    data_ID[i] = pszData[i + 1];
                }
                return true;
            }
            else
            {
                data_ID = new byte[2];
                return false;
            }
        }

        /// <summary>
        /// ȡIDCard
        /// </summary>
        /// <param name="data_ID">ǩϢ</param>
        /// <returns></returns>
        public static bool ReadIDCard(ref byte[] data_ID)
        {
            byte[] pszData = new byte[255];
            int res = 0;
            res = EM125k_read(0, pszData);
            if (res == 0)
            {
                data_ID = new byte[pszData[0]];
                for (int i = 0; i < data_ID.Length; i++)
                {
                    data_ID[i] = pszData[i + 1];
                }
                return true;
            }
            else
            {
                data_ID = new byte[2];
                return false;
            }
        }


        public static bool EM125k_WriteHitag(int page, byte[] data)
        {
            int res;
            res = EM125k_WriteHitagPage(page, data);
            if (res == 0)
                return true;
            else
                return false;
        }


        /// <summary>
        /// ֽת10ƵϢ
        /// </summary>
        /// <param name="pszData"></param>
        /// <returns></returns>
        public static Int32 IDTag_num(byte[] pszData)
        {
            int iLength=pszData.Length;
            if (iLength>=4)
            {
                byte[] dataNum = new byte[4];
                for (int i = 0; i < 4; i++)
                {
                    dataNum[i] = pszData[iLength - 1 - i];
                }

                return BitConverter.ToInt32(dataNum, 0);
            }
            else{
                return 0;
            }
            
        }




        /// <summary>
        /// ȡIDCard
        /// </summary>
        /// <param name="data_ID">ǩϢ</param>
        /// <returns></returns>
        public static bool ReadIDCard_FHX(ref byte[] data_ID)
        {
            byte[] pszData = new byte[255];
            int res = 0;
            res = EM125k_read(1, pszData);
            if (res == 0)
            {
                data_ID = new byte[pszData[0]];
                for (int i = 0; i < data_ID.Length; i++)
                {
                    data_ID[i] = pszData[i + 1];
                }
                return true;
            }
            else
            {
                data_ID = new byte[2];
                return false;
            }
        }



        /// <summary>
        /// ȡǩ
        /// </summary>
        /// <param name="animalCardInfo">ǩϢ</param>
        /// <returns></returns>
        public static bool readAnimalTags_FDX(ref animalCard animalCardInfo)
        {
            byte[] pszData = new byte[255];
            int res = 0;
            res = EM125k_read(1, pszData);
            if (res == 0)
            {
                byte[] National_temp = new byte[8];
                for (int i = 0; i < 8; i++)
                {
                    National_temp[i] = pszData[i + 1];
                }
                animalCardInfo.NationalID = BitConverter.ToUInt64(National_temp, 0);
                byte[] Country_temp = new byte[2];
                for (int i = 0; i < 2; i++)
                {
                    Country_temp[i] = pszData[i + 9];
                }
                animalCardInfo.CountryID = (int)BitConverter.ToInt16(Country_temp, 0);

                byte[] Reserved_temp = new byte[2];
                for (int i = 0; i < 2; i++)
                {
                    Reserved_temp[i] = pszData[i + 11];
                }
                animalCardInfo.Reserved = (int)BitConverter.ToInt16(Reserved_temp, 0);
                return true;
            }
            else
            {
                return false;
            }
        }
            /// <summary>
        /// ȡ˫ǩ
        /// </summary>
        /// <param name="animalCardInfo">ǩϢ</param>
        /// <returns></returns>
        public static bool readAnimalTags_HDX(ref animalCard animalCardInfo)
        {
            byte[] pszData = new byte[255];
            int res = 0;
            res = EM125k_read(2, pszData);
            if (res == 0)
            {
                byte[] National_temp = new byte[8];
                for (int i = 0; i < 8; i++)
                {
                    National_temp[i] = pszData[i + 1];
                }
                animalCardInfo.NationalID = BitConverter.ToUInt64(National_temp, 0);
                byte[] Country_temp = new byte[2];
                for (int i = 0; i < 2; i++)
                {
                    Country_temp[i] = pszData[i + 9];
                }
                animalCardInfo.CountryID = (int)BitConverter.ToInt16(Country_temp, 0);

                byte[] Reserved_temp = new byte[2];
                for (int i = 0; i < 2; i++)
                {
                    Reserved_temp[i] = pszData[i + 11];
                }
                animalCardInfo.Reserved = (int)BitConverter.ToInt16(Reserved_temp, 0);
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// EM4405
        /// </summary>
        /// <param name="data_ID"></param>
        /// <returns></returns>
        public static bool ReadEM4450UID(ref byte[] data_ID)
        {
            byte[] pszData = new byte[255];
            int res = 0;
            res = EM125K_GetEm4450UID(pszData);
            if (res == 0)
            {
                data_ID = new byte[pszData[0]];
                for (int i = 0; i < data_ID.Length; i++)
                {
                    data_ID[i] = pszData[i + 1];
                }
                return true;
            }
            else
            {
                data_ID = new byte[2];
                return false;
            }
        }
        public static bool HID_ReadUID(uint[] UID, byte[] ExtData)
        {
            int res = 0;
            res = HID_ReadID(UID, ExtData);
            if (res == 0)
                return true;
            else
                return false;
        }
        /// <summary>
        /// ȡHitagĳһҳ
        /// </summary>
        /// <param name="page"></param>
        /// <param name="HitagData"></param>
        /// <returns></returns>
        public static bool EM125k_ReadHitag(int page, ref string HitagData)
        {
            byte[] data = new byte[255];
            int dataLeng = 0;
            int reslut = EM125k_ReadHitag(page, data);

            if (reslut == 0)
            {
                dataLeng = data[0]; //õݵĳ
                byte[] byteHitag = new byte[dataLeng];
                for (int k = 0; k < byteHitag.Length; k++)
                {
                    // byteHitag[0]=data[k+1];
                    HitagData += data[k + 1].ToString("X2");
                }
                return true;
            }
            else
            {
                return false;
            }

        }
        /// <summary>
        /// ȡEM4305ĳһҳ
        /// </summary>
        /// <param name="page"></param>
        /// <param name="EM4305"></param>
        /// <returns></returns>
        public static bool EM125k_ReadEM4305(int page, ref string EM4305)
        {
            byte[] data = new byte[255];
            int dataLeng = 0;
            int reslut = EM125k_Read4305(page, data);

            if (reslut == 0)
            {
                dataLeng = data[0]; //õݵĳ
                byte[] byteHitag = new byte[dataLeng];
                for (int k = 0; k < byteHitag.Length; k++)
                {
                    // byteHitag[0]=data[k+1];
                    EM4305 += data[k + 1].ToString("X2");
                }
                return true;
            }
            else
            {
                return false;
            }

        }
        /// <summary>
        /// дEM4305ĳһҳ
        /// </summary>
        /// <param name="page"></param>
        /// <param name="EM4305"></param>
        /// <returns></returns>
        public static bool EM125k_WriteM4305(int page, byte[] EM4305)
        {
            int reslut = EM125k_Write4305(page, EM4305);
            if (reslut == 0)
            {
                return true;
            }
            else
            {
                return false;
            }

        }

       //Կ
        public static int EM125k_EM4305_KEYAUTH(byte[] key)
        {
            return EM125k_EM4305_KEY_AUTH(key);
        }

        /// <summary>
        /// Կ
        /// </summary>
        /// <param name="oldkey"></param>
        /// <param name="newkey"></param>
        /// <returns></returns>
        public static int EM125k_EM4305_KEYCHANGE(byte[] oldkey,byte[] newkey)
        {
            int r= EM125k_EM4305_KEY_CHANGE(oldkey, newkey);
            return r;
        }


        /// <summary>
        /// ܹ
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        public static bool EM125k_EM4305_KEYENABLE(byte[] key)
        {
            int r=EM125k_EM4305_KEY_ENABLE(key);
            if (r == 0)
                return true;
            else
                return false;
        }
        
        /// <summary>
        /// üܹ
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        public static bool EM125k_EM4305_KEYDISABLE(byte[] key)
        {
         
            int r=EM125k_EM4305_KEY_DISABLE(key);
            if (r == 0)
                return true;
            else 
                return false;
        }

 
 


        /// <summary>
        /// дEM4305ĳһҳ
        /// </summary>
        /// <param name="page"></param>
        /// <param name="EM4305"></param>
        /// <returns></returns>
        public static bool EM125k_Write4305(byte[] ukey,int page, byte[] EM4305)
        {
            int reslut = EM125k_Write4305_EX(ukey, page, EM4305);
            if (reslut == 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// ȡEM4305ĳһҳ
        /// </summary>
        /// <param name="page"></param>
        /// <param name="EM4305"></param>
        /// <returns></returns>
        public static bool EM125k_ReadEM4305(byte[] ukey,int page, ref string EM4305)
        {
            byte[] data = new byte[255];
            int dataLeng = 0;
            int reslut = EM125k_Read4305_EX(ukey, page, data);

            if (reslut == 0)
            {
                dataLeng = data[0]; //õݵĳ
                byte[] byteHitag = new byte[dataLeng];
                for (int k = 0; k < byteHitag.Length; k++)
                {
                    // byteHitag[0]=data[k+1];
                    EM4305 += data[k + 1].ToString("X2");
                }
                return true;
            }
            else
            {
                return false;
            }

        }
        public static bool SetSerialBaudRate(int module, int baudRate)
        {
            try
            {
                 bool result=SetSerialPortBaudRate(module, baudRate);
                 return result;
            }
            catch (System.Exception ex)
            {
                return false;
            }

        }

        
    }   
}
